#! /bin/sh
#
# Program NAND FLASH
#
#rm /var/run/testsysled.pid

echo none > /sys/devices/platform/leds-gpio/leds/wifi_led2/trigger
echo 0 > /sys/devices/platform/leds-gpio/leds/wifi_led2/brightness

[ "$1" != "1" ] && mcu2ti -w SSAUPON

killall config_daemon 
killall McuLinkManger.sh
killall McuLink
[ -x /etc/init.d/asus_daemon ] && /etc/init.d/asus_daemon stop
[ -x /etc/init.d/minidlna ] && /etc/init.d/minidlna stop
[ -x /etc/init.d/lighttpd ] && /etc/init.d/lighttpd stop
[ -x /etc/init.d/smbd ] && /etc/init.d/smbd stop

#testsysled.sh &
if [ -f MLO_V1027 ]; then
	flash_eraseall /dev/mtd0
fi
flash_eraseall /dev/mtd1
flash_eraseall /dev/mtd2
#flash_eraseall /dev/mtd3
if [ -f u-boot_V1027.img ]; then
	flash_eraseall /dev/mtd4
fi
flash_eraseall /dev/mtd5
if [ -f uImage_V1027 ]; then
	flash_eraseall /dev/mtd6
fi
if [ -f ubi_upgrade.img ]; then
	flash_eraseall /dev/mtd7
fi
if [ -f ubi_V1027.img ]; then
	flash_eraseall /dev/mtd8
fi

if [ -f MLO_V1027 ]; then
	nandwrite -p /dev/mtd0 MLO_V1027
fi

if [ -f u-boot_V1027.img ]; then
	nandwrite -p /dev/mtd4 u-boot_V1027.img
fi

if [ -f uImage_V1027 ]; then
	nandwrite -p /dev/mtd6 uImage_V1027
fi

mkdir /media/extfs/ubifs1

if [ -f ubi_upgrade.img ]; then
	ubiformat /dev/mtd7 -f ubi_upgrade.img -s 512 -O 2048
	ubiattach /dev/ubi_ctrl -m 7 -O 2048
	mount -t ubifs /dev/ubi0_0 /media/extfs/ubifs1
	sync
	umount /media/extfs/ubifs1
	ubidetach -m 7
	ubiattach /dev/ubi_ctrl -m 7 -O 2048
	mount -t ubifs /dev/ubi0_0 /media/extfs/ubifs1
	ls /media/extfs/ubifs1
	umount /media/extfs/ubifs1
	ubidetach -m 7
fi

if [ -f ubi_V1027.img ]; then
	ubiformat /dev/mtd8 -f ubi_V1027.img -s 512 -O 2048
	ubiattach /dev/ubi_ctrl -m 8 -O 2048
	mount -t ubifs /dev/ubi0_0 /media/extfs/ubifs1
	sync
	umount /media/extfs/ubifs1
	ubidetach -m 8
	ubiattach /dev/ubi_ctrl -m 8 -O 2048
	mount -t ubifs /dev/ubi0_0 /media/extfs/ubifs1
	ls /media/extfs/ubifs1
	umount /media/extfs/ubifs1
	ubidetach -m 8
fi

echo "Programming finished......"
#rm /var/run/testsysled.pid
#################
echo 1 > /var/tmp/Upgrade.conf
echo "Upgrade flash successfully." >> /var/tmp/Upgrade.conf
#echo 1 >/sys/class/gpio/gpio27/value

if [ "$1" != "1" ]; then
	mcu2ti -w SSAUPOFF
	sleep 1
	mcu2ti -w SSWLON
#	diag mcu_test_mode on
#	diag white_led on
fi
